
//----------------------------------------------------
// The following code was generated by CUP v0.11b 20160615 (GIT 4ac7450)
//----------------------------------------------------

package parser;

import java_cup.runtime.*;
import java.util.Scanner;
import java.util.Stack;
import java_cup.runtime.XMLElement;

/** CUP v0.11b 20160615 (GIT 4ac7450) generated parser.
  */
@SuppressWarnings({"rawtypes"})
public class Parser extends java_cup.runtime.lr_parser {

 public final Class getSymbolContainer() {
    return sym.class;
}

  /** Default constructor. */
  @Deprecated
  public Parser() {super();}

  /** Constructor which sets the default scanner. */
  @Deprecated
  public Parser(java_cup.runtime.Scanner s) {super(s);}

  /** Constructor which sets the default scanner. */
  public Parser(java_cup.runtime.Scanner s, java_cup.runtime.SymbolFactory sf) {super(s,sf);}

  /** Production table. */
  protected static final short _production_table[][] = 
    unpackFromStrings(new String[] {
    "\000\023\000\002\003\003\000\002\002\004\000\002\002" +
    "\004\000\002\002\003\000\002\011\002\000\002\010\005" +
    "\000\002\004\005\000\002\004\005\000\002\004\004\000" +
    "\002\004\003\000\002\005\005\000\002\005\005\000\002" +
    "\005\003\000\002\006\003\000\002\006\005\000\002\006" +
    "\003\000\002\007\006\000\002\007\005\000\002\007\003" +
    "" });

  /** Access to production table. */
  public short[][] production_table() {return _production_table;}

  /** Parse-action table. */
  protected static final short[][] _action_table = 
    unpackFromStrings(new String[] {
    "\000\040\000\012\006\005\013\004\014\007\021\011\001" +
    "\002\000\024\004\uffef\005\uffef\006\uffef\007\uffef\010\uffef" +
    "\012\uffef\015\uffef\016\uffef\017\uffef\001\002\000\010\013" +
    "\004\014\007\021\011\001\002\000\014\002\001\006\005" +
    "\013\004\014\007\021\011\001\002\000\012\006\005\013" +
    "\004\014\007\021\011\001\002\000\014\004\ufff8\005\ufff8" +
    "\006\ufff8\015\ufff8\017\ufff8\001\002\000\020\004\ufff4\005" +
    "\ufff4\006\ufff4\007\ufff4\010\ufff4\015\ufff4\017\ufff4\001\002" +
    "\000\004\002\036\001\002\000\024\004\ufff2\005\ufff2\006" +
    "\ufff2\007\ufff2\010\ufff2\012\032\015\ufff2\016\031\017\ufff2" +
    "\001\002\000\014\002\ufffe\006\ufffe\013\ufffe\014\ufffe\021" +
    "\ufffe\001\002\000\020\004\ufff5\005\ufff5\006\ufff5\007\026" +
    "\010\025\015\ufff5\017\ufff5\001\002\000\010\004\ufffd\005" +
    "\017\006\021\001\002\000\010\013\004\014\007\021\011" +
    "\001\002\000\004\004\023\001\002\000\010\013\004\014" +
    "\007\021\011\001\002\000\014\004\ufffa\005\ufffa\006\ufffa" +
    "\015\ufffa\017\ufffa\001\002\000\014\002\ufffc\006\ufffc\013" +
    "\ufffc\014\ufffc\021\ufffc\001\002\000\014\004\ufffb\005\ufffb" +
    "\006\ufffb\015\ufffb\017\ufffb\001\002\000\010\013\004\014" +
    "\007\021\011\001\002\000\010\013\004\014\007\021\011" +
    "\001\002\000\014\004\ufff6\005\ufff6\006\ufff6\015\ufff6\017" +
    "\ufff6\001\002\000\014\004\ufff7\005\ufff7\006\ufff7\015\ufff7" +
    "\017\ufff7\001\002\000\012\006\005\013\004\014\007\021" +
    "\011\001\002\000\004\013\033\001\002\000\024\004\ufff0" +
    "\005\ufff0\006\ufff0\007\ufff0\010\ufff0\012\ufff0\015\ufff0\016" +
    "\ufff0\017\ufff0\001\002\000\010\005\017\006\021\017\035" +
    "\001\002\000\024\004\ufff1\005\ufff1\006\ufff1\007\ufff1\010" +
    "\ufff1\012\ufff1\015\ufff1\016\ufff1\017\ufff1\001\002\000\004" +
    "\002\000\001\002\000\010\005\017\006\021\015\040\001" +
    "\002\000\020\004\ufff3\005\ufff3\006\ufff3\007\ufff3\010\ufff3" +
    "\015\ufff3\017\ufff3\001\002\000\014\002\uffff\006\uffff\013" +
    "\uffff\014\uffff\021\uffff\001\002\000\014\004\ufff9\005\ufff9" +
    "\006\ufff9\015\ufff9\017\ufff9\001\002" });

  /** Access to parse-action table. */
  public short[][] action_table() {return _action_table;}

  /** <code>reduce_goto</code> table. */
  protected static final short[][] _reduce_table = 
    unpackFromStrings(new String[] {
    "\000\040\000\020\002\005\003\011\004\015\005\007\006" +
    "\014\007\012\010\013\001\001\000\002\001\001\000\010" +
    "\005\041\006\014\007\012\001\001\000\014\004\015\005" +
    "\007\006\014\007\012\010\040\001\001\000\012\004\036" +
    "\005\007\006\014\007\012\001\001\000\002\001\001\000" +
    "\002\001\001\000\002\001\001\000\002\001\001\000\002" +
    "\001\001\000\002\001\001\000\004\011\017\001\001\000" +
    "\010\005\023\006\014\007\012\001\001\000\002\001\001" +
    "\000\010\005\021\006\014\007\012\001\001\000\002\001" +
    "\001\000\002\001\001\000\002\001\001\000\010\005\027" +
    "\006\014\007\012\001\001\000\010\005\026\006\014\007" +
    "\012\001\001\000\002\001\001\000\002\001\001\000\012" +
    "\004\033\005\007\006\014\007\012\001\001\000\002\001" +
    "\001\000\002\001\001\000\002\001\001\000\002\001\001" +
    "\000\002\001\001\000\002\001\001\000\002\001\001\000" +
    "\002\001\001\000\002\001\001" });

  /** Access to <code>reduce_goto</code> table. */
  public short[][] reduce_table() {return _reduce_table;}

  /** Instance of action encapsulation class. */
  protected CUP$Parser$actions action_obj;

  /** Action encapsulation object initializer. */
  protected void init_actions()
    {
      action_obj = new CUP$Parser$actions(this);
    }

  /** Invoke a user supplied parse action. */
  public java_cup.runtime.Symbol do_action(
    int                        act_num,
    java_cup.runtime.lr_parser parser,
    java.util.Stack            stack,
    int                        top)
    throws java.lang.Exception
  {
    /* call code in generated class */
    return action_obj.CUP$Parser$do_action(act_num, parser, stack, top);
  }

  /** Indicates start state. */
  public int start_state() {return 0;}
  /** Indicates start production. */
  public int start_production() {return 1;}

  /** <code>EOF</code> Symbol index. */
  public int EOF_sym() {return 0;}

  /** <code>error</code> Symbol index. */
  public int error_sym() {return 1;}



	int contador = 0;
	double somatorio = 0.0;	

	Stack<Double> pilha = new Stack<Double>(); ;


/** Cup generated class to encapsulate user supplied action code.*/
@SuppressWarnings({"rawtypes", "unchecked", "unused"})
class CUP$Parser$actions {
  private final Parser parser;

  /** Constructor */
  CUP$Parser$actions(Parser parser) {
    this.parser = parser;
  }

  /** Method 0 with the actual generated action code for actions 0 to 300. */
  public final java_cup.runtime.Symbol CUP$Parser$do_action_part00000000(
    int                        CUP$Parser$act_num,
    java_cup.runtime.lr_parser CUP$Parser$parser,
    java.util.Stack            CUP$Parser$stack,
    int                        CUP$Parser$top)
    throws java.lang.Exception
    {
      /* Symbol object for return from actions */
      java_cup.runtime.Symbol CUP$Parser$result;

      /* select the action based on the action number */
      switch (CUP$Parser$act_num)
        {
          /*. . . . . . . . . . . . . . . . . . . .*/
          case 0: // start01 ::= expr_list 
            {
              Object RESULT =null;
		 								
					System.out.println("Foram reconhecidas e computadas:");
					System.out.println(parser.contador + " expressoes");
					System.out.println("Cujo somatorio foi:" + parser.somatorio);
				
              CUP$Parser$result = parser.getSymbolFactory().newSymbol("start01",1, ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 1: // $START ::= start01 EOF 
            {
              Object RESULT =null;
		int start_valleft = ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-1)).left;
		int start_valright = ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-1)).right;
		Object start_val = (Object)((java_cup.runtime.Symbol) CUP$Parser$stack.elementAt(CUP$Parser$top-1)).value;
		RESULT = start_val;
              CUP$Parser$result = parser.getSymbolFactory().newSymbol("$START",0, ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-1)), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          /* ACCEPT */
          CUP$Parser$parser.done_parsing();
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 2: // expr_list ::= expr_list expr_ptv 
            {
              Object RESULT =null;
		int eleft = ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()).left;
		int eright = ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()).right;
		Double e = (Double)((java_cup.runtime.Symbol) CUP$Parser$stack.peek()).value;
		 
					parser.contador++;
					parser.somatorio += e.doubleValue();								
				
              CUP$Parser$result = parser.getSymbolFactory().newSymbol("expr_list",0, ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-1)), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 3: // expr_list ::= expr_ptv 
            {
              Object RESULT =null;
		int eleft = ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()).left;
		int eright = ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()).right;
		Double e = (Double)((java_cup.runtime.Symbol) CUP$Parser$stack.peek()).value;
		
					parser.contador++;
					parser.somatorio += e.doubleValue();								
				
              CUP$Parser$result = parser.getSymbolFactory().newSymbol("expr_list",0, ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 4: // NT$0 ::= 
            {
              Double RESULT =null;
 
					Double a1 = parser.pilha.pop();
					System.out.println("= " + a1); 
					RESULT = a1;
					//RESULT = new Double(e.doubleValue());
				
              CUP$Parser$result = parser.getSymbolFactory().newSymbol("NT$0",7, ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 5: // expr_ptv ::= expr NT$0 PTVIRG 
            {
              Double RESULT =null;
              // propagate RESULT from NT$0
                RESULT = (Double) ((java_cup.runtime.Symbol) CUP$Parser$stack.elementAt(CUP$Parser$top-1)).value;

              CUP$Parser$result = parser.getSymbolFactory().newSymbol("expr_ptv",6, ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-2)), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 6: // expr ::= expr MAIS term 
            {
              Double RESULT =null;
			
					//System.out.print(" executei + ");	
					Double a1 = parser.pilha.pop();
					Double a2 = parser.pilha.pop();
					Double resultado = a1 + a2;
					parser.pilha.push(resultado);
					System.out.print(" pop("+a1+"),");
					System.out.print(" pop("+a2+")");
					System.out.print(" + -> push("+resultado+").");

					//RESULT = e + t; 
				
              CUP$Parser$result = parser.getSymbolFactory().newSymbol("expr",2, ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-2)), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 7: // expr ::= expr MENOS term 
            {
              Double RESULT =null;
		
					//System.out.print(" executei - ");	
					Double a1 = parser.pilha.pop();
					Double a2 = parser.pilha.pop();
					Double resultado = a1 - a2;
					parser.pilha.push(resultado);
					System.out.print(" pop("+a1+"),");
					System.out.print(" pop("+a2+") ");
					System.out.print(" - -> push("+resultado+").");
					//RESULT = e - t;
				
              CUP$Parser$result = parser.getSymbolFactory().newSymbol("expr",2, ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-2)), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 8: // expr ::= MENOS term 
            {
              Double RESULT =null;
		
					//System.out.print(" executei -u ");	
					Double a1 = parser.pilha.pop();					
					Double resultado = -1.0 * a1;
					parser.pilha.push(resultado);
					System.out.print(" pop("+a1+")");					
					System.out.print(" - -> push("+resultado+").");
					//RESULT = -t;
				
              CUP$Parser$result = parser.getSymbolFactory().newSymbol("expr",2, ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-1)), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 9: // expr ::= term 
            {
              Double RESULT =null;

              CUP$Parser$result = parser.getSymbolFactory().newSymbol("expr",2, ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 10: // term ::= factor MULT term 
            {
              Double RESULT =null;
		 
				 	//System.out.print(" executei * ");	
					Double a1 = parser.pilha.pop();
					Double a2 = parser.pilha.pop();
					Double resultado = a1 * a2;
					parser.pilha.push(resultado);	
					System.out.print(" pop("+a1+"),");
					System.out.print(" pop("+a2+")");
					System.out.print(" * -> push("+resultado+").");
					//RESULT = f * t;  
				
              CUP$Parser$result = parser.getSymbolFactory().newSymbol("term",3, ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-2)), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 11: // term ::= factor DIV term 
            {
              Double RESULT =null;
		 
					//System.out.print(" executei % ");	
					Double a1 = parser.pilha.pop();
					Double a2 = parser.pilha.pop();
					Double resultado = a1 % a2;
					parser.pilha.push(resultado);
					System.out.print(" pop("+a1+"), ");
					System.out.print(" pop("+a2+") ");
					System.out.print("% -> push("+resultado+").");
					//RESULT = f % t; 					
				
              CUP$Parser$result = parser.getSymbolFactory().newSymbol("term",3, ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-2)), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 12: // term ::= factor 
            {
              Double RESULT =null;

              CUP$Parser$result = parser.getSymbolFactory().newSymbol("term",3, ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 13: // factor ::= NUMBER 
            {
              Double RESULT =null;
		int nleft = ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()).left;
		int nright = ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()).right;
		Double n = (Double)((java_cup.runtime.Symbol) CUP$Parser$stack.peek()).value;
		 
					double aux = new Double(n.doubleValue());
					System.out.print(aux+" ");
					parser.pilha.push(aux);
				
              CUP$Parser$result = parser.getSymbolFactory().newSymbol("factor",4, ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 14: // factor ::= ABRE_PARENT expr FECHA_PARENT 
            {
              Double RESULT =null;
		int eleft = ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-1)).left;
		int eright = ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-1)).right;
		Double e = (Double)((java_cup.runtime.Symbol) CUP$Parser$stack.elementAt(CUP$Parser$top-1)).value;

              CUP$Parser$result = parser.getSymbolFactory().newSymbol("factor",4, ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-2)), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 15: // factor ::= designator 
            {
              Double RESULT =null;
		int dleft = ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()).left;
		int dright = ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()).right;
		Double d = (Double)((java_cup.runtime.Symbol) CUP$Parser$stack.peek()).value;
		
				   double aux = new Double(1.0);
				   System.out.print(aux+" ");
				   parser.pilha.push(aux);
				   //RESULT = new Double(1.0);
		  		
              CUP$Parser$result = parser.getSymbolFactory().newSymbol("factor",4, ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 16: // designator ::= designator ABRE_COLCH expr FECHA_COLCH 
            {
              Double RESULT =null;

              CUP$Parser$result = parser.getSymbolFactory().newSymbol("designator",5, ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-3)), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 17: // designator ::= designator PTO IDENT 
            {
              Double RESULT =null;

              CUP$Parser$result = parser.getSymbolFactory().newSymbol("designator",5, ((java_cup.runtime.Symbol)CUP$Parser$stack.elementAt(CUP$Parser$top-2)), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /*. . . . . . . . . . . . . . . . . . . .*/
          case 18: // designator ::= IDENT 
            {
              Double RESULT =null;

              CUP$Parser$result = parser.getSymbolFactory().newSymbol("designator",5, ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), ((java_cup.runtime.Symbol)CUP$Parser$stack.peek()), RESULT);
            }
          return CUP$Parser$result;

          /* . . . . . .*/
          default:
            throw new Exception(
               "Invalid action number "+CUP$Parser$act_num+"found in internal parse table");

        }
    } /* end of method */

  /** Method splitting the generated action code into several parts. */
  public final java_cup.runtime.Symbol CUP$Parser$do_action(
    int                        CUP$Parser$act_num,
    java_cup.runtime.lr_parser CUP$Parser$parser,
    java.util.Stack            CUP$Parser$stack,
    int                        CUP$Parser$top)
    throws java.lang.Exception
    {
              return CUP$Parser$do_action_part00000000(
                               CUP$Parser$act_num,
                               CUP$Parser$parser,
                               CUP$Parser$stack,
                               CUP$Parser$top);
    }
}

}
